/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
	"time"
)

// CancelProductOrder Request for cancellation an existing product order
type CancelProductOrder struct {
	// id of the cancellation request (this is not an order id)
	Id *string `json:"id,omitempty"`
	// Hyperlink to access the cancellation request
	Href *string `json:"href,omitempty"`
	// Reason why the order is cancelled.
	CancellationReason *string `json:"cancellationReason,omitempty"`
	// Date when the order is cancelled.
	EffectiveCancellationDate *time.Time `json:"effectiveCancellationDate,omitempty"`
	// Date when the submitter wants the order to be cancelled
	RequestedCancellationDate *time.Time `json:"requestedCancellationDate,omitempty"`
	ProductOrder ProductOrderRef `json:"productOrder"`
	State *TaskStateType `json:"state,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewCancelProductOrder instantiates a new CancelProductOrder object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCancelProductOrder(productOrder ProductOrderRef, ) *CancelProductOrder {
	this := CancelProductOrder{}
	this.ProductOrder = productOrder
	return &this
}

// NewCancelProductOrderWithDefaults instantiates a new CancelProductOrder object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCancelProductOrderWithDefaults() *CancelProductOrder {
	this := CancelProductOrder{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *CancelProductOrder) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *CancelProductOrder) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *CancelProductOrder) SetId(v string) {
	o.Id = &v
}

// GetHref returns the Href field value if set, zero value otherwise.
func (o *CancelProductOrder) GetHref() string {
	if o == nil || o.Href == nil {
		var ret string
		return ret
	}
	return *o.Href
}

// GetHrefOk returns a tuple with the Href field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetHrefOk() (*string, bool) {
	if o == nil || o.Href == nil {
		return nil, false
	}
	return o.Href, true
}

// HasHref returns a boolean if a field has been set.
func (o *CancelProductOrder) HasHref() bool {
	if o != nil && o.Href != nil {
		return true
	}

	return false
}

// SetHref gets a reference to the given string and assigns it to the Href field.
func (o *CancelProductOrder) SetHref(v string) {
	o.Href = &v
}

// GetCancellationReason returns the CancellationReason field value if set, zero value otherwise.
func (o *CancelProductOrder) GetCancellationReason() string {
	if o == nil || o.CancellationReason == nil {
		var ret string
		return ret
	}
	return *o.CancellationReason
}

// GetCancellationReasonOk returns a tuple with the CancellationReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetCancellationReasonOk() (*string, bool) {
	if o == nil || o.CancellationReason == nil {
		return nil, false
	}
	return o.CancellationReason, true
}

// HasCancellationReason returns a boolean if a field has been set.
func (o *CancelProductOrder) HasCancellationReason() bool {
	if o != nil && o.CancellationReason != nil {
		return true
	}

	return false
}

// SetCancellationReason gets a reference to the given string and assigns it to the CancellationReason field.
func (o *CancelProductOrder) SetCancellationReason(v string) {
	o.CancellationReason = &v
}

// GetEffectiveCancellationDate returns the EffectiveCancellationDate field value if set, zero value otherwise.
func (o *CancelProductOrder) GetEffectiveCancellationDate() time.Time {
	if o == nil || o.EffectiveCancellationDate == nil {
		var ret time.Time
		return ret
	}
	return *o.EffectiveCancellationDate
}

// GetEffectiveCancellationDateOk returns a tuple with the EffectiveCancellationDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetEffectiveCancellationDateOk() (*time.Time, bool) {
	if o == nil || o.EffectiveCancellationDate == nil {
		return nil, false
	}
	return o.EffectiveCancellationDate, true
}

// HasEffectiveCancellationDate returns a boolean if a field has been set.
func (o *CancelProductOrder) HasEffectiveCancellationDate() bool {
	if o != nil && o.EffectiveCancellationDate != nil {
		return true
	}

	return false
}

// SetEffectiveCancellationDate gets a reference to the given time.Time and assigns it to the EffectiveCancellationDate field.
func (o *CancelProductOrder) SetEffectiveCancellationDate(v time.Time) {
	o.EffectiveCancellationDate = &v
}

// GetRequestedCancellationDate returns the RequestedCancellationDate field value if set, zero value otherwise.
func (o *CancelProductOrder) GetRequestedCancellationDate() time.Time {
	if o == nil || o.RequestedCancellationDate == nil {
		var ret time.Time
		return ret
	}
	return *o.RequestedCancellationDate
}

// GetRequestedCancellationDateOk returns a tuple with the RequestedCancellationDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetRequestedCancellationDateOk() (*time.Time, bool) {
	if o == nil || o.RequestedCancellationDate == nil {
		return nil, false
	}
	return o.RequestedCancellationDate, true
}

// HasRequestedCancellationDate returns a boolean if a field has been set.
func (o *CancelProductOrder) HasRequestedCancellationDate() bool {
	if o != nil && o.RequestedCancellationDate != nil {
		return true
	}

	return false
}

// SetRequestedCancellationDate gets a reference to the given time.Time and assigns it to the RequestedCancellationDate field.
func (o *CancelProductOrder) SetRequestedCancellationDate(v time.Time) {
	o.RequestedCancellationDate = &v
}

// GetProductOrder returns the ProductOrder field value
func (o *CancelProductOrder) GetProductOrder() ProductOrderRef {
	if o == nil  {
		var ret ProductOrderRef
		return ret
	}

	return o.ProductOrder
}

// GetProductOrderOk returns a tuple with the ProductOrder field value
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetProductOrderOk() (*ProductOrderRef, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.ProductOrder, true
}

// SetProductOrder sets field value
func (o *CancelProductOrder) SetProductOrder(v ProductOrderRef) {
	o.ProductOrder = v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *CancelProductOrder) GetState() TaskStateType {
	if o == nil || o.State == nil {
		var ret TaskStateType
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetStateOk() (*TaskStateType, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *CancelProductOrder) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given TaskStateType and assigns it to the State field.
func (o *CancelProductOrder) SetState(v TaskStateType) {
	o.State = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *CancelProductOrder) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *CancelProductOrder) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *CancelProductOrder) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *CancelProductOrder) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *CancelProductOrder) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *CancelProductOrder) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *CancelProductOrder) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CancelProductOrder) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *CancelProductOrder) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *CancelProductOrder) SetType(v string) {
	o.Type = &v
}

func (o CancelProductOrder) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if o.Href != nil {
		toSerialize["href"] = o.Href
	}
	if o.CancellationReason != nil {
		toSerialize["cancellationReason"] = o.CancellationReason
	}
	if o.EffectiveCancellationDate != nil {
		toSerialize["effectiveCancellationDate"] = o.EffectiveCancellationDate
	}
	if o.RequestedCancellationDate != nil {
		toSerialize["requestedCancellationDate"] = o.RequestedCancellationDate
	}
	if true {
		toSerialize["productOrder"] = o.ProductOrder
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullableCancelProductOrder struct {
	value *CancelProductOrder
	isSet bool
}

func (v NullableCancelProductOrder) Get() *CancelProductOrder {
	return v.value
}

func (v *NullableCancelProductOrder) Set(val *CancelProductOrder) {
	v.value = val
	v.isSet = true
}

func (v NullableCancelProductOrder) IsSet() bool {
	return v.isSet
}

func (v *NullableCancelProductOrder) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCancelProductOrder(val *CancelProductOrder) *NullableCancelProductOrder {
	return &NullableCancelProductOrder{value: val, isSet: true}
}

func (v NullableCancelProductOrder) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCancelProductOrder) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


